## gr-framework 0.73.9+dfsg

=== lib/grm/Makefile ===
ifeq ($(strip $(THIRDPARTYDIR)),)
override THIRDPARTYDIR = $(abspath $(CURDIR)/../../3rdparty/build)
endif

       GRDIR = /usr/local/gr
      LIBDIR = $(DESTDIR)$(GRDIR)/lib
      INCDIR = $(DESTDIR)$(GRDIR)/include
    SHAREDIR = $(DESTDIR)$(GRDIR)/share

UNAME := $(shell uname)

     GRMOBJS = src/grm/args.o \
               src/grm/backtrace.o \
               src/grm/base64.o \
               src/grm/bson.o \
               src/grm/dump.o \
               src/grm/dynamic_args_array.o \
               src/grm/error.o \
               src/grm/event.o \
               src/grm/interaction.o \
               src/grm/json.o \
               src/grm/layout.o \
               src/grm/layout_c.o \
               src/grm/layout_error.o \
               src/grm/logging.o \
               src/grm/memwriter.o \
               src/grm/net.o \
               src/grm/plot.o \
               src/grm/util.o \
               src/grm/utilcpp.o \
               src/grm/import.o \
               src/grm/datatype/double_map.o \
               src/grm/datatype/size_t_list.o \
               src/grm/datatype/string_array_map.o \
               src/grm/datatype/string_list.o \
               src/grm/datatype/string_map.o \
               src/grm/datatype/uint_map.o \
               src/grm/dom_render/context.o \
               src/grm/dom_render/Drawable.o \
               src/grm/dom_render/ManageCustomColorIndex.o \
               src/grm/dom_render/ManageGRContextIds.o \
               src/grm/dom_render/ManageZIndex.o \
               src/grm/dom_render/render.o \
               src/grm/dom_render/graphics_tree/Comment.o \
               src/grm/dom_render/graphics_tree/Document.o \
               src/grm/dom_render/graphics_tree/Element.o \
               src/grm/dom_render/graphics_tree/Node.o \
               src/grm/dom_render/graphics_tree/Value.o \
               src/grm/dom_render/graphics_tree/util.o
   XERCESCDEFS =
   XERCESCINC =
ifdef USE_STATIC_XERCESC_LIBS
   XERCESCLIBS = $(THIRDPARTYDIR)/lib/libxerces-c.a $(THIRDPARTYDIR)/lib/libicuuc.a $(THIRDPARTYDIR)/lib/libicudata.a
else
   XERCESCLIBS = -lxerces-c
endif

     DEFINES = -DBUILDING_GR -DGRDIR=\"$(GRDIR)\" $(XERCESCDEFS)
    INCLUDES = -I./include \
               -I./src \
               -I../gks \
               -I../gr \
               -I../gr3 \
               -I$(THIRDPARTYDIR)/include \
               $(XERCESCINC)
          CC = cc
      CFLAGS = $(DEFINES) -std=c90 -O3 -Wall -fPIC -fvisibility=hidden $(EXTRA_CFLAGS)
    CXXFLAGS = $(DEFINES) -std=c++17 -O3 -Wall -fPIC -fvisibility=hidden $(EXTRA_CXXFLAGS)
         AR ?= ar
     RANLIB ?= ar ts
ifeq ($(UNAME), Darwin)
GR_SHARED_LIBRARY_SUFFIX ?= .dylib
     CFLAGS += -mmacosx-version-min=10.15
   CXXFLAGS += -mmacosx-version-min=10.15
INSTALL_NAME = -Wl,-install_name,@rpath/libGRM${GR_SHARED_LIBRARY_SUFFIX}
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,@loader_path/. -mmacosx-version-min=10.15
     SOFLAGS = -dynamiclib
else
GR_SHARED_LIBRARY_SUFFIX ?= .so
INSTALL_NAME =
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,'$$ORIGIN/.'
     SOFLAGS = -shared
endif
      GRLIBS = -L ../gr/ -lGR
     GR3LIBS = -L ../gr3/ -lGR3
        LIBS = $(GRLIBS) $(GR3LIBS) $(XERCESCLIBS) -lm

grplot_support =
ifneq ($(QT5_QMAKE),)
ifneq ($(QT5_QMAKE),false)
    grplot_support = yes
endif
endif
ifneq ($(QT6_QMAKE),)
ifneq ($(QT6_QMAKE),false)
    grplot_support = yes
endif
endif

.c.o:
	$(CC) -o $@ -c $(INCLUDES) $(CFLAGS) $<

.cxx.o:
	$(CXX) -o $@ -c $(INCLUDES) $(CXXFLAGS) $<

default:
	$(MAKE) -C ../.. Makedefs
	$(MAKE) `cat ../../Makedefs`

all: targets

ifdef grplot_support
targets: prerequisites libGRM.a libGRM${GR_SHARED_LIBRARY_SUFFIX} grplot
else
targets: prerequisites libGRM.a libGRM${GR_SHARED_LIBRARY_SUFFIX}
endif

prerequisites:
	$(MAKE) -C ../../3rdparty/ PREFIX=$(THIRDPARTYDIR)

libGR:
	$(MAKE) -C ../gr

libGR3:
	$(MAKE) -C ../gr3

libGRM.a: $(GRMOBJS)
	$(AR) crv $@ $?
	$(RANLIB) $@

libGRM${GR_SHARED_LIBRARY_SUFFIX}: $(GRMOBJS) libGR libGR3
	$(CXX) -o $@ $(SOFLAGS) $(GRMOBJS) $(LIBS) $(LDFLAGS) $(INSTALL_NAME)

grplot:
	$(MAKE) -C grplot -f makefile.mak GRDIR=$(GRDIR) THIRDPARTYDIR=$(THIRDPARTYDIR)

install:
	@if [ ! -d $(DESTDIR)$(GRDIR) ]; then mkdir -m 755 $(DESTDIR)$(GRDIR); fi
	@if [ ! -d $(LIBDIR) ]; then mkdir -m 755 $(LIBDIR); fi
	cp -p libGRM.* $(LIBDIR)
	@if [ ! -d $(INCDIR) ]; then mkdir -m 755 $(INCDIR); fi
	cp -p include/grm.h $(INCDIR)
	cp -rp include/grm $(INCDIR)/
	@if [ ! -d $(SHAREDIR)/xml/GRM ]; then mkdir -m 755 -p $(SHAREDIR)/xml/GRM; fi
	cp -p src/grm/dom_render/graphics_tree/schema.xsd $(SHAREDIR)/xml/GRM/grm_graphics_tree_schema.xsd
	cp -p src/grm/dom_render/graphics_tree/private_schema.xsd $(SHAREDIR)/xml/GRM/grm_graphics_tree_private_schema.xsd
ifeq ($(UNAME), Darwin)
	@if [ -d grplot/grplot.app ]; then \
		$(MAKE) -C grplot -f makefile.mak install; \
	fi
else
	@if [ -f grplot/grplot ]; then \
		$(MAKE) -C grplot -f makefile.mak install; \
	fi
endif

clean:
	$(MAKE) -C grplot -f makefile.mak clean
	rm -f grplot/.qmake.stash
	rm -f *.so \
	      *.a \
	      src/grm/*.o \
	      src/grm/datatype/*.o \
	      src/grm/dom_render/*.o \
	      src/grm/dom_render/graphics_tree/*.o \
	      *${GR_SHARED_LIBRARY_SUFFIX}


.PHONY: all targets install clean prerequisites libGR libGR3 grplot
.SUFFIXES:  # Delete the default suffixes
.SUFFIXES: .c .cxx .o  # List all suffixes for suffix rules explicitly

## gr-framework 0.73.8+dfsg

=== debian/changelog ===
gr-framework (0.73.8+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debian/control
    - Use linux-any to exclude hurd-amd64, hurd-i386.

 -- HAYASHI Kentaro <kenhys@xdump.org>  Wed, 30 Oct 2024 19:57:54 +0900

gr-framework (0.73.7+dfsg-2) unstable; urgency=medium

  * Team upload.
  * No change source-only upload for testing migration.

 -- Boyuan Yang <byang@debian.org>  Mon, 16 Sep 2024 23:08:07 -0400

gr-framework (0.73.7+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1077974)

 -- HAYASHI Kentaro <kenhys@xdump.org>  Mon, 05 Aug 2024 20:54:46 +0900

=== debian/control ===
Source: gr-framework
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Kentaro HAYASHI <kenhys@xdump.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dvipng,
 libagg2-dev,
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libgl-dev,
 libglfw3-dev,
 libgs-dev,
 libgtk2.0-dev,
 libjpeg-dev,
 libqhull-dev,
 libswscale-dev,
 libx11-dev,
 libxerces-c-dev,
 libxft-dev,
 libxt-dev,
 libzmq3-dev,
 qmake6,
 qt6-base-dev,
 qtbase5-dev
Standards-Version: 4.7.0
Homepage: https://gr-framework.org/
Vcs-Browser: https://salsa.debian.org/science-team/gr-framework
Vcs-Git: https://salsa.debian.org/science-team/gr-framework.git

# Support typical use cases.
Package: gr-framework
Architecture: linux-any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version}),
 gr-framework-bin (= ${binary:Version}),
 gr-framework-plugin-base (= ${binary:Version})
Description: Universal framework of Graphical Kernel System (GKS) and OpenGL (metapackage)
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.

# gksqt depends Qt6, so install Qt6 plugin too.
Package: gr-framework-bin
Section: utils
Architecture: linux-any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version}),
 gr-framework-plugin-qt6 (= ${binary:Version})
Description: Binary of Graphical Kernel System (GKS) and OpenGL
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains binary executable files for GR.

Package: libgr-framework-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Development files of Graphical Kernel System (GKS) and OpenGL
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains development files for GR.

# base and cairo plugin support most of output format
Package: libgr-framework0
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 dvipng,
 gr-framework-plugin-base (= ${binary:Version}),
 gr-framework-plugin-cairo (= ${binary:Version})
Description: Library of Graphical Kernel System (GKS) and OpenGL
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains runtime library for GR.

Package: gr-framework-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Documentation of Graphical Kernel System (GKS) and OpenGL
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains documentation for GKS.

Package: gr-framework-plugin-base
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Basic plugins for Graphical Kernel System (GKS) and OpenGL
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains comprehensive plugins - PGF (Portable Graphics Format),
 SVG (Scalable Vector Graphics) and WMF (Windows Metafile) plugins.

Package: gr-framework-plugin-full
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 gr-framework-plugin-agg,
 gr-framework-plugin-cairo,
 gr-framework-plugin-gl,
 gr-framework-plugin-gs,
 gr-framework-plugin-qt5,
 gr-framework-plugin-qt6,
 gr-framework-plugin-x11,
 gr-framework-plugin-video,
 gr-framework-plugin-zmq
Description: All plugins for Graphical Kernel System (GKS) and OpenGL (metapackage)
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package installs all of plugins for GKS.

Package: gr-framework-plugin-agg
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Graphical Kernel System (GKS) and OpenGL plugin for AGG
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains plugin for Anti-Grain Geometry library.

Package: gr-framework-plugin-cairo
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Graphical Kernel System (GKS) and OpenGL plugin for Cairo
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains plugin for Cairo Graphics.

Package: gr-framework-plugin-gl
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Graphical Kernel System (GKS) and OpenGL plugin for WGL/CGL/GLX
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains plugin for OpenGL.

Package: gr-framework-plugin-gs
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Graphical Kernel System (GKS) and OpenGL plugin for Ghostscript
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains plugin for Ghostscript.

Package: gr-framework-plugin-qt5
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Graphical Kernel System (GKS) and OpenGL plugin for Qt5
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains plugin for Qt5.

Package: gr-framework-plugin-qt6
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Graphical Kernel System (GKS) and OpenGL plugin for Qt6
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains plugin for Qt6.

Package: gr-framework-plugin-x11
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Graphical Kernel System (GKS) and OpenGL plugin for GKS 5 (X11)
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains plugin for GKS 5 (X11).

Package: gr-framework-plugin-video
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Graphical Kernel System (GKS) and OpenGL plugin for Video
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains plugin for Video output.

Package: gr-framework-plugin-zmq
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libgr-framework0 (= ${binary:Version})
Description: Graphical Kernel System (GKS) and OpenGL plugin for ZeroMQ
 GR is a universal framework for cross-platform visualization
 applications. It offers developers a compact, portable and consistent
 graphics library for their programs. Applications range from
 publication quality 2D graphs to the representation of complex 3D
 scenes.
 .
 This package contains plugin for ZeroMQ.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	-DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	-DCMAKE_PREFIX_PATH=/usr/include/agg2

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/tmp -name '*.a' | xargs rm -f
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gr
	find $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) -name '*plugin.so' | xargs -I% mv % $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/gr
	mkdir -p $(CURDIR)/debian/tmp/usr/share/doc/gr-framework-doc/
	mv $(CURDIR)/debian/tmp/usr/share/doc/grplot/* $(CURDIR)/debian/tmp/usr/share/doc/gr-framework-doc/
	mv $(CURDIR)/debian/tmp/usr/share/doc/GR/* $(CURDIR)/debian/tmp/usr/share/doc/gr-framework-doc/

=== debian/tests/control ===
Tests: plugin-agg plugin-cairo plugin-gs plugin-video
Depends:
 @builddeps@,
 gr-framework-plugin-agg,
 gr-framework-plugin-base,
 gr-framework-plugin-cairo,
 gr-framework-plugin-gl,
 gr-framework-plugin-gs,
 gr-framework-plugin-video,
 libgr-framework-dev,
 mediainfo

## gr-framework 0.73.10+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
include(GetVersionFromGit)
get_version_from_git(GR_VERSION GR_VERSION_FULL)

project(
  GR
  VERSION ${GR_VERSION}
  LANGUAGES C CXX
)

include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

# Honor `C_VISIBILITY_PRESET hidden` and `CXX_VISIBILITY_PRESET hidden` in static libraries
cmake_policy(SET CMP0063 NEW)

check_cxx_compiler_flag("-Werror=implicit" ERROR_IMPLICIT_SUPPORTED)
if(ERROR_IMPLICIT_SUPPORTED)
  set(COMPILER_OPTION_ERROR_IMPLICIT
      "-Werror=implicit"
      CACHE INTERNAL "Compiler flag for generating errors on implicit declarations"
  )
else()
  set(COMPILER_OPTION_ERROR_IMPLICIT
      ""
      CACHE INTERNAL "Compiler flag for generating errors on implicit declarations"
  )
endif()

if(UNIX)
  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX
        "/usr/local/gr"
        CACHE PATH "GR install prefix" FORCE
    )
  endif()
endif()
set(GR_DIRECTORY
    "${CMAKE_INSTALL_PREFIX}"
    CACHE STRING "Default value for GRDIR"
)
option(GR_BUILD_DEMOS "Build demos for GR" OFF)
option(GR_BUILD_GKSM "Build GKS metafile reader for GR" OFF)
option(GR_INSTALL "Create installation target for GR" ON)
option(GR_USE_BUNDLED_LIBRARIES "Use thirdparty libraries bundled with GR" OFF)
option(GR_MANUAL_MOC_AND_RCC "Manually run moc and rcc instead of relying on AUTOMOC and AUTORCC" OFF)
option(GR_FIND_QT5_BY_VARIABLES "Find Qt5 based on the variables Qt5_INCLUDE_DIR and Qt5_LIBRARY_DIR" OFF)
option(GR_PREFER_XCODEBUILD "Prefer xcodebuild to build macOS applications if available" ON)

if(GR_USE_BUNDLED_LIBRARIES)
  list(APPEND CMAKE_FIND_ROOT_PATH "${CMAKE_CURRENT_LIST_DIR}/3rdparty/build/")
  set(GR_THIRDPARTY_LIBRARY_PREFIX ${CMAKE_STATIC_LIBRARY_PREFIX})
  set(GR_THIRDPARTY_LIBRARY_SUFFIX ${CMAKE_STATIC_LIBRARY_SUFFIX})
else()
  set(GR_THIRDPARTY_LIBRARY_PREFIX ${CMAKE_SHARED_LIBRARY_PREFIX})
  set(GR_THIRDPARTY_LIBRARY_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

if(GR_FIND_QT5_BY_VARIABLES)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/optional/qt5")
endif()

if(WIN32)
  set(GR_PLUGIN_SUFFIX ".dll")
else()
  set(GR_PLUGIN_SUFFIX ".so")
endif()

if(APPLE)
  set(DEFAULT_SHARED_LIBRARY_SUFFIX ".dylib")
else()
  set(DEFAULT_SHARED_LIBRARY_SUFFIX "${GR_PLUGIN_SUFFIX}")
endif()

set(GR_SHARED_LIBRARY_SUFFIX
    "${DEFAULT_SHARED_LIBRARY_SUFFIX}"
    CACHE STRING "File suffix for shared libraries"
)

set(CMAKE_FIND_PACKAGE_PREFER_CONFIG
    TRUE
    CACHE BOOL ""
)

# Find the following packages always in system locations even if `GR_USE_BUNDLED_LIBRARIES` is set, because they are not
# located in 3rdparty
find_package(X11)
find_package(Fontconfig)
find_package(OpenGL OPTIONAL_COMPONENTS OpenGL)
if(${CMAKE_VERSION} VERSION_GREATER "3.16.0")
  find_package(
    Qt6
    OPTIONAL_COMPONENTS
      Widgets
      Core
      Network
      Gui
      PrintSupport
  )
endif()
find_package(
  Qt5
  OPTIONAL_COMPONENTS
    Widgets
    Core
    Network
    Gui
    PrintSupport
)
find_package(Qt4)

# Find the following packages only in 3rdparty, if `GR_USE_BUNDLED_LIBRARIES` is set
if(GR_USE_BUNDLED_LIBRARIES)
  set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM ONLY)
endif()
find_package(Freetype)
if(TARGET freetype AND NOT TARGET Freetype::Freetype)
  add_library(Freetype::Freetype ALIAS freetype)
endif()
find_package(Jpeg REQUIRED)
find_package(Libpng REQUIRED)
find_package(ZLIB REQUIRED)
find_package(Qhull REQUIRED)
if(TARGET Qhull::qhullstatic_r AND NOT TARGET Qhull::qhull_r)
  add_library(Qhull::qhull_r ALIAS Qhull::qhullstatic_r)
endif()
find_package(Tiff)
find_package(Ffmpeg 57.48.100)
find_package(glfw3)
if(TARGET glfw AND NOT TARGET Glfw::Glfw)
  add_library(Glfw::Glfw ALIAS glfw)
endif()
find_package(ZeroMQ)
if(NOT TARGET ZeroMQ::ZeroMQ)
  if(TARGET libzmq)
    add_library(ZeroMQ::ZeroMQ ALIAS libzmq)
  elseif(TARGET libzmq-static)
    add_library(ZeroMQ::ZeroMQ ALIAS libzmq-static)
    get_target_property(ZeroMQ_LIBRARY libzmq-static LOCATION)
  endif()
endif()
find_package(Cairo)
find_package(Agg)
find_package(Gs)
find_package(XercesC)

if(APPLE)
  set(INSTALL_RPATH "${GR_DIRECTORY}/lib/;@loader_path/.")
else()
  set(INSTALL_RPATH "${GR_DIRECTORY}/lib/;$ORIGIN/.")
endif()

if(Qt4_FOUND
   OR (Qt5Widgets_FOUND
       AND Qt5Core_FOUND
       AND Qt5Network_FOUND
      )
   OR (Qt6Widgets_FOUND
       AND Qt6Core_FOUND
       AND Qt6Network_FOUND
      )
)
  if(GR_MANUAL_MOC_AND_RCC)
    if(NOT QT_MOC_EXECUTABLE)
      find_program(QT_MOC_EXECUTABLE moc CMAKE_FIND_ROOT_PATH_BOTH)
    endif()
    if(NOT QT_MOC_EXECUTABLE)
      message(FATAL_ERROR "Could not find moc but GR_MANUAL_MOC_AND_RCC is set.")
    endif()
    if(NOT QT_RCC_EXECUTABLE)
      find_program(QT_RCC_EXECUTABLE rcc CMAKE_FIND_ROOT_PATH_BOTH)
    endif()
    if(NOT QT_RCC_EXECUTABLE)
      message(FATAL_ERROR "Could not find rcc but GR_MANUAL_MOC_AND_RCC is set.")
    endif()
  endif()
endif()
if(Qt4_FOUND)
  set(QT4_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS QT_INCLUDE_DIR)
    set(QT4_MOC_INCLUDE_FLAGS ${QT4_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt4_LIBRARY_DIR)
    get_filename_component(Qt4_LIBRARY_DIR "${QT_LIBRARY_DIR}/../.." ABSOLUTE)
  endif()
endif()
if(Qt5Widgets_FOUND
   AND Qt5Core_FOUND
   AND Qt5Network_FOUND
)
  set(QT5_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS Qt5Core_INCLUDE_DIRS Qt5Gui_INCLUDE_DIRS Qt5Widgets_INCLUDE_DIRS)
    set(QT5_MOC_INCLUDE_FLAGS ${QT5_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt5_LIBRARY_DIR)
    get_filename_component(Qt5_LIBRARY_DIR "${Qt5_DIR}/../.." ABSOLUTE)
  endif()
endif()
if(Qt6Widgets_FOUND
   AND Qt6Core_FOUND
   AND Qt6Network_FOUND
)
  set(QT6_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS Qt6Core_INCLUDE_DIRS Qt6Gui_INCLUDE_DIRS Qt6Widgets_INCLUDE_DIRS)
    set(QT6_MOC_INCLUDE_FLAGS ${QT6_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt6_LIBRARY_DIR)
    get_filename_component(Qt6_LIBRARY_DIR "${Qt6_DIR}/../.." ABSOLUTE)
  endif()
endif()

if(X11_FOUND)
  # older versions of FindX11.cmake set variables but do not create targets
  if(NOT TARGET X11::X11
     AND X11_INCLUDE_DIR
     AND X11_X11_LIB
     AND X11_Xft_LIB
  )
    add_library(X11::X11 UNKNOWN IMPORTED)
    set_target_properties(
      X11::X11
      PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${X11_INCLUDE_DIR}/"
                 IMPORTED_LINK_INTERFACE_LANGUAGES "C"
                 IMPORTED_LOCATION "${X11_X11_LIB}"
                 INTERFACE_LINK_LIBRARIES "${X11_Xft_LIB}"
    )
  endif()
  if(NOT TARGET X11::Xt
     AND X11_INCLUDE_DIR
     AND X11_Xt_LIB
     AND TARGET X11::X11
  )
    add_library(X11::Xt UNKNOWN IMPORTED)
    set_target_properties(
      X11::Xt
      PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${X11_INCLUDE_DIR}/"
                 IMPORTED_LINK_INTERFACE_LANGUAGES "C"
                 IMPORTED_LOCATION "${X11_Xt_LIB}"
                 INTERFACE_LINK_LIBRARIES "X11::X11"
    )
  endif()
endif()

set(GKS_SOURCES
    lib/gks/afm.c
    lib/gks/font.c
    lib/gks/socket.c
    lib/gks/ft.c
    lib/gks/malloc.c
    lib/gks/util.c
    lib/gks/compress.c
    lib/gks/gks.c
    lib/gks/mf.c
    lib/gks/win.c
    lib/gks/gksforbnd.c
    lib/gks/pdf.c
    lib/gks/wiss.c
    lib/gks/dl.c
    lib/gks/plugin.c
    lib/gks/error.c
    lib/gks/io.c
    lib/gks/ps.c
    lib/gks/resample.c
)

add_library(gks_static STATIC ${GKS_SOURCES})
add_library(gks_shared SHARED ${GKS_SOURCES})

foreach(LIBRARY gks_static gks_shared)
  if(LIBRARY MATCHES "static")
    set(GKS_LINK_MODE PUBLIC)
  else()
    set(GKS_LINK_MODE PRIVATE)
  endif()
  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_definitions(${LIBRARY} PRIVATE _CRT_SECURE_NO_WARNINGS)
  endif()
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} pthread)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} m)
  endif()
  if(FREETYPE_FOUND)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} Freetype::Freetype)
  else()
    target_compile_definitions(
      ${LIBRARY}
      ${GKS_LINK_MODE}
      NO_FT
    )
  endif()
  target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} ZLIB::ZLIB)
  target_compile_definitions(
    ${LIBRARY}
    ${GKS_LINK_MODE}
    HAVE_ZLIB
  )
  if(UNIX)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} dl)
  elseif(WIN32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} ws2_32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} msimg32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} gdi32)
  endif()
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    target_compile_options(${LIBRARY} ${GKS_LINK_MODE} -pthread)
  endif()
  target_compile_options(${LIBRARY} PRIVATE ${COMPILER_OPTION_ERROR_IMPLICIT})
  target_include_directories(
    ${LIBRARY} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib/gks/>
                      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )
  target_compile_definitions(${LIBRARY} PRIVATE GRDIR="${GR_DIRECTORY}")
  set_target_properties(
    ${LIBRARY}
    PROPERTIES C_STANDARD 90
               C_EXTENSIONS OFF
               C_STANDARD_REQUIRED ON
               POSITION_INDEPENDENT_CODE ON
               PREFIX "lib"
               IMPORT_PREFIX "lib"
               OUTPUT_NAME GKS
               INSTALL_RPATH "${INSTALL_RPATH}"
  )
endforeach()
unset(GKS_LINK_MODE)
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  set_target_properties(gks_static PROPERTIES OUTPUT_NAME GKSstatic)
endif()
set_target_properties(gks_shared PROPERTIES SUFFIX "${GR_SHARED_LIBRARY_SUFFIX}" EXPORT_NAME GKS)
add_library(GR::GKS ALIAS gks_static)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/gr_version.h
     "#ifndef GR_VERSION\n#define GR_VERSION \"${GR_VERSION_FULL}\"\n#endif\n"
)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/gr_version.h PROPERTIES GENERATED TRUE)

set(GR_SOURCES
    lib/gr/boundary.c
    lib/gr/contour.c
    lib/gr/contourf.c
    lib/gr/delaunay.c
    lib/gr/gr.c
    lib/gr/grforbnd.c
    lib/gr/gridit.c
    lib/gr/image.c
    lib/gr/import.c
    lib/gr/interp2.c
    lib/gr/stream.c
    lib/gr/md5.c
    lib/gr/shade.c
    lib/gr/spline.c
    lib/gr/strlib.c
    lib/gr/text.c
    lib/gr/mathtex2.c
    lib/gr/mathtex2_kerning.c
    lib/gr/mathtex2.tab.c
    lib/gr/threadpool.c
    ${CMAKE_CURRENT_BINARY_DIR}/gr_version.h
)

add_library(gr_static STATIC ${GR_SOURCES})
add_library(gr_shared SHARED ${GR_SOURCES})

foreach(LIBRARY gr_static gr_shared)
  if(LIBRARY MATCHES "static")
    set(GR_LINK_MODE PUBLIC)
  else()
    set(GR_LINK_MODE PRIVATE)
  endif()
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} gks_static)
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    target_link_libraries(${LIBRARY} ${GR_LINK_MODE} m)
  endif()
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} Qhull::qhull_r)
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} Jpeg::Jpeg)
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} Libpng::Libpng)
  if(WIN32)
    target_link_libraries(${LIBRARY} ${GR_LINK_MODE} ws2_32)
  endif()
  target_include_directories(
    ${LIBRARY} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib/gr/>
                      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )
  target_include_directories(${LIBRARY} PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_definitions(${LIBRARY} PRIVATE _CRT_SECURE_NO_WARNINGS)
  endif()
  target_compile_definitions(${LIBRARY} PRIVATE GRDIR="${GR_DIRECTORY}")
  target_compile_options(${LIBRARY} PRIVATE ${COMPILER_OPTION_ERROR_IMPLICIT})
  set_target_properties(
    ${LIBRARY}
    PROPERTIES C_STANDARD 90
               C_EXTENSIONS OFF
               C_STANDARD_REQUIRED ON
               POSITION_INDEPENDENT_CODE ON

=== debian/changelog ===
gr-framework (0.73.10+dfsg-2build1) plucky; urgency=medium

  * No-change rebuild for fixed libagg2t64 dependency.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Jan 2025 19:59:44 +0100

gr-framework (0.73.10+dfsg-2) unstable; urgency=medium

  * debian/rules:
    - Fix wrong shlibs:Depends= for agg plugin

 -- Kentaro Hayashi <kenhys@xdump.org>  Wed, 25 Dec 2024 19:25:39 +0900

gr-framework (0.73.10+dfsg-1) unstable; urgency=medium

  * New upstream version 0.73.10+dfsg

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 22 Dec 2024 19:41:32 +0900

gr-framework (0.73.9+dfsg-1) unstable; urgency=medium

  * New upstream version 0.73.9+dfsg
  * debian/control:
    - Fix W:intra-source-package-circular-dependency.

 -- Kentaro Hayashi <kenhys@xdump.org>  Tue, 10 Dec 2024 13:52:46 +0900

=== debian/control ===
--- 
+++ 
@@ -42,7 +42,8 @@
  ${misc:Depends},
  libgr-framework0 (= ${binary:Version}),
  gr-framework-bin (= ${binary:Version}),
- gr-framework-plugin-base (= ${binary:Version})
+ gr-framework-plugin-base (= ${binary:Version}),
+ gr-framework-plugin-cairo (= ${binary:Version})
 Description: Universal framework of Graphical Kernel System (GKS) and OpenGL (metapackage)
  GR is a universal framework for cross-platform visualization
  applications. It offers developers a compact, portable and consistent
@@ -93,9 +94,7 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- dvipng,
- gr-framework-plugin-base (= ${binary:Version}),
- gr-framework-plugin-cairo (= ${binary:Version})
+ dvipng
 Description: Library of Graphical Kernel System (GKS) and OpenGL
  GR is a universal framework for cross-platform visualization
  applications. It offers developers a compact, portable and consistent

## gr-framework 0.73.12%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -284,7 +284,7 @@
     target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} pthread)
     target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} m)
   endif()
-  if(FREETYPE_FOUND)
+  if(Freetype_FOUND)
     target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} Freetype::Freetype)
   else()
     target_compile_definitions(

=== js/Makefile ===
ifeq ($(strip $(THIRDPARTYDIR)),)
override THIRDPARTYDIR = $(abspath $(CURDIR)/../3rdparty/build)
endif

ifneq ($(notdir $(CC)),emcc)
rerun_with_emmake:
	 emmake make
endif

OPTS = \
		--no-heap-copy \
		-s USE_ICU=1
ifndef DEBUG
    OPTS  += -O3
else
    OPTS  += -s ASSERTIONS=2 -s SAFE_HEAP=1 -s STACK_OVERFLOW_CHECK=2
endif
   DEFINES = -DEMSCRIPTEN -D__SVR4 -DGRDIR=\"\" -DNO_GL -DNO_THREADS
    CFLAGS = $(DEFINES) $(OPTS) $(EXTRA_CFLAGS)
  CXXFLAGS = $(DEFINES) $(OPTS) -std=c++17 $(EXTRA_CXXFLAGS)
   LDFLAGS = $(DEFINES) $(OPTS) $(EXTRA_LDFLAGS) \
		-sDYNCALLS=1 \
		-s ERROR_ON_UNDEFINED_SYMBOLS=0 \
		-s LEGACY_GL_EMULATION=1 \
		-s 'EXPORTED_RUNTIME_METHODS=["ccall", "cwrap", "getValue", "setValue", "addFunction", "removeFunction", "UTF8ToString", "stringToUTF8", "lengthBytesUTF8"]' \
		-s NO_EXIT_RUNTIME=0 \
		-s WASM=0 \
		-s TOTAL_MEMORY=33554432 \
		-s ALLOW_MEMORY_GROWTH=1 \
		-s RESERVED_FUNCTION_POINTERS=4 \
		-s ALLOW_TABLE_GROWTH=1
   JPEGDIR = ../3rdparty/jpeg
    PNGDIR = ../3rdparty/libpng16
   ZLIBDIR = ../3rdparty/zlib
  QHULLDIR = ../3rdparty/qhull
     FTDIR = ../3rdparty/freetype
XERCESCDIR = ../3rdparty/xerces-c
    GKSDIR = ../lib/gks
     GRDIR = ../lib/gr
    GR3DIR = ../lib/gr3
    GRMDIR = ../lib/grm
  INCLUDES = -I$(THIRDPARTYDIR)/include/ \
             -I$(GRMDIR)/include \
             -I$(GRMDIR)/src \
             -I$(GR3DIR) \
             -I$(GRDIR) \
             -I$(GKSDIR) \
             -I$(JPEGDIR) \
             -I$(PNGDIR) \
             -I$(ZLIBDIR) \
             -I$(QHULLDIR) \
             -I$(FTDIR)
   GKSOBJS = jsplugin.o \
             $(GKSDIR)/afm.o \
             $(GKSDIR)/error.o \
             $(GKSDIR)/font.o \
             $(GKSDIR)/ft.o \
             $(GKSDIR)/gks.o \
             $(GKSDIR)/io.o \
             $(GKSDIR)/malloc.o \
             $(GKSDIR)/util.o \
             $(GKSDIR)/wiss.o
    GROBJS = $(GRDIR)/contour.o \
             $(GRDIR)/contourf.o \
             $(GRDIR)/delaunay.o \
             $(GRDIR)/gr.o \
             $(GRDIR)/grforbnd.o \
             $(GRDIR)/gridit.o \
             $(GRDIR)/image.o \
             $(GRDIR)/import.o \
             $(GRDIR)/interp2.o \
             $(GRDIR)/mathtex2.o \
             $(GRDIR)/mathtex2.tab.o \
             $(GRDIR)/mathtex2_kerning.o \
             $(GRDIR)/md5.o \
             $(GRDIR)/shade.o \
             $(GRDIR)/spline.o \
             $(GRDIR)/stream.o \
             $(GRDIR)/strlib.o \
             $(GRDIR)/text.o
   GR3OBJS = $(GR3DIR)/gr3.o \
             $(GR3DIR)/gr3_convenience.o \
             $(GR3DIR)/gr3_gr.o \
             $(GR3DIR)/gr3_html.o \
             $(GR3DIR)/gr3_jpeg.o \
             $(GR3DIR)/gr3_mc.o \
             $(GR3DIR)/gr3_png.o \
             $(GR3DIR)/gr3_povray.o \
             $(GR3DIR)/gr3_sr.o
   GRMOBJS = $(GRMDIR)/src/grm/args.o \
             $(GRMDIR)/src/grm/backtrace.o \
             $(GRMDIR)/src/grm/base64.o \
             $(GRMDIR)/src/grm/bson.o \
             $(GRMDIR)/src/grm/dump.o \
             $(GRMDIR)/src/grm/dynamic_args_array.o \
             $(GRMDIR)/src/grm/error.o \
             $(GRMDIR)/src/grm/event.o \
             $(GRMDIR)/src/grm/interaction.o \
             $(GRMDIR)/src/grm/json.o \
             $(GRMDIR)/src/grm/layout.o \
             $(GRMDIR)/src/grm/layout_c.o \
             $(GRMDIR)/src/grm/layout_error.o \
             $(GRMDIR)/src/grm/logging.o \
             $(GRMDIR)/src/grm/memwriter.o \
             $(GRMDIR)/src/grm/net.o \
             $(GRMDIR)/src/grm/plot.o \
             $(GRMDIR)/src/grm/util.o \
             $(GRMDIR)/src/grm/utilcpp.o \
             $(GRMDIR)/src/grm/import.o \
             $(GRMDIR)/src/grm/datatype/double_map.o \
             $(GRMDIR)/src/grm/datatype/size_t_list.o \
             $(GRMDIR)/src/grm/datatype/string_array_map.o \
             $(GRMDIR)/src/grm/datatype/string_list.o \
             $(GRMDIR)/src/grm/datatype/string_map.o \
             $(GRMDIR)/src/grm/datatype/uint_map.o \
             $(GRMDIR)/src/grm/dom_render/context.o \
             $(GRMDIR)/src/grm/dom_render/Drawable.o \
             $(GRMDIR)/src/grm/dom_render/ManageCustomColorIndex.o \
             $(GRMDIR)/src/grm/dom_render/ManageGRContextIds.o \
             $(GRMDIR)/src/grm/dom_render/ManageZIndex.o \
             $(GRMDIR)/src/grm/dom_render/render.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Comment.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Document.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Element.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Node.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Value.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/util.o
      OBJS = $(GRMOBJS) $(GR3OBJS) $(GROBJS) $(GKSOBJS)
      LIBS = $(JPEGDIR)/libjpeg.a \
             $(PNGDIR)/libpng.a \
             $(ZLIBDIR)/libz.a \
             $(QHULLDIR)/libqhull_r.a \
             $(FTDIR)/libfreetype.a \
             $(XERCESCDIR)/libxerces-c.a

.PHONY: default clean .SECONDARY .FORCE

.SUFFIXES:
.SUFFIXES: .c .cxx .o

.SECONDARY:

.FORCE:

default: gr.js

../lib/gr/gr_version.h: .FORCE
	$(MAKE) -C ../lib/gr gr_version.h

gr.js: module.js libGR.js api.js jsterm.js
	cat $^ > $@

fonts:
	mkdir fonts
	cp -p $(GKSDIR)/fonts/CMUSerif-Math.ttf $(GKSDIR)/fonts/DejaVuSans.ttf $(GKSDIR)/fonts/STIXTwoMath.ttf $(GKSDIR)/fonts/gksfont.dat $(GKSDIR)/fonts/mathtex2_offsets.bin fonts/

$(JPEGDIR)/libjpeg.a:
	$(MAKE) -C $(JPEGDIR)

$(PNGDIR)/libpng.a:
	$(MAKE) -C $(PNGDIR)

$(ZLIBDIR)/libz.a:
	$(MAKE) -C $(ZLIBDIR)

$(QHULLDIR)/libqhull_r.a:
	$(MAKE) -C $(QHULLDIR)

$(FTDIR)/libfreetype.a:
	$(MAKE) -C $(FTDIR)

$(XERCESCDIR)/libxerces-c.a:
	$(MAKE) -C $(XERCESCDIR) libxerces-c.a

$(GRDIR)/gr.o: ../lib/gr/gr_version.h

%.o: %.c $(LIBS)
	$(CC) -c $(CFLAGS) -o $@ $< $(INCLUDES)

%.o: %.cxx $(LIBS)
	$(CXX) -c $(CXXFLAGS) -o $@ $< $(INCLUDES)

libGR.js: $(OBJS) $(LIBS) library.js fonts
	$(CXX) $(LDFLAGS) \
	--embed-file fonts/gksfont.dat --embed-file fonts/CMUSerif-Math.ttf --embed-file fonts/DejaVuSans.ttf --embed-file fonts/STIXTwoMath.ttf --embed-file fonts/mathtex2_offsets.bin \
	--js-library library.js \
	-o $@ $(OBJS) $(LIBS) \
	-s EXPORTED_FUNCTIONS="['_gr_opengks', '_gr_closegks', '_gr_inqdspsize', '_gr_openws', '_gr_closews', '_gr_activatews', '_gr_deactivatews', '_gr_clearws', '_gr_updatews', '_gr_polyline', '_gr_polymarker', '_gr_text', '_gr_inqtext', '_gr_fillarea', '_gr_cellarray', '_gr_spline', '_gr_gridit', '_gr_setlinetype', '_gr_inqlinetype', '_gr_setlinewidth', '_gr_inqlinewidth', '_gr_setlinecolorind', '_gr_inqlinecolorind', '_gr_setmarkertype', '_gr_inqmarkertype', '_gr_setmarkersize', '_gr_setmarkercolorind', '_gr_inqmarkercolorind', '_gr_settextfontprec', '_gr_setcharexpan', '_gr_setcharspace', '_gr_settextcolorind', '_gr_setcharheight', '_gr_setcharup', '_gr_settextpath', '_gr_settextalign', '_gr_setfillintstyle', '_gr_setfillstyle', '_gr_setfillcolorind', '_gr_setcolorrep', '_gr_setscale', '_gr_inqscale', '_gr_setwindow', '_gr_inqwindow', '_gr_setviewport', '_gr_inqviewport', '_gr_selntran', '_gr_setclip', '_gr_setwswindow', '_gr_setwsviewport', '_gr_createseg', '_gr_copysegws', '_gr_redrawsegws', '_gr_setsegtran', '_gr_closeseg', '_gr_emergencyclosegks', '_gr_updategks', '_gr_setspace', '_gr_inqspace', '_gr_textext', '_gr_inqtextext', '_gr_setscientificformat', '_gr_axes', '_gr_grid', '_gr_verrorbars', '_gr_herrorbars', '_gr_polyline3d', '_gr_axes3d', '_gr_titles3d', '_gr_surface', '_gr_contour', '_gr_hexbin', '_gr_setcolormap', '_gr_inqcolormap', '_gr_colorbar', '_gr_inqcolor', '_gr_inqcolorfromrgb', '_gr_hsvtorgb', '_gr_tick', '_gr_validaterange', '_gr_adjustrange', '_gr_beginprint', '_gr_beginprintext', '_gr_endprint', '_gr_ndctowc', '_gr_wctondc', '_gr_drawrect', '_gr_fillrect', '_gr_drawarc', '_gr_fillarc', '_gr_drawpath', '_gr_setarrowstyle', '_gr_drawarrow', '_gr_readimage', '_gr_drawimage', '_gr_importgraphics', '_gr_setshadow', '_gr_settransparency', '_gr_setcoordxform', '_gr_begingraphics', '_gr_endgraphics', '_gr_drawgraphics', '_gr_mathtex', '_gr_beginselection', '_gr_endselection', '_gr_moveselection', '_gr_resizeselection', '_gr_inqbbox', '_gr_precision', '_gr_setregenflags', '_gr_inqregenflags', '_gr_savestate', '_gr_restorestate', '_gr_selectcontext', '_gr_destroycontext', '_gr_uselinespec', '_gr_selntran', '_gks_get_dash_list', '_gr_shade', '_gr_shadepoints', '_gr_shadelines', '_gr_panzoom', '_gr_path', '_gr_setborderwidth', '_gr_inqborderwidth', '_gr_setbordercolorind', '_gr_inqbordercolorind', '_gr_selectclipxform', '_gr_inqclipxform', '_gr_settextencoding', '_grm_read', '_grm_args_new', '_grm_args_push', '_grm_args_delete', '_grm_plot', '_grm_get_stdout', '_grm_dump_json', '_grm_dump', '_grm_input', '_grm_merge', '_grm_merge_named', '_grm_switch', '_grm_get_box', '_grm_get_tooltip', '_grm_register', '_grm_unregister', '_grm_dump_json_str', '_grm_load_from_str', '_grm_is3d', '_malloc', '_free']"

clean:
	rm -f libGR.js gr.js *.js.mem
	rm -rf fonts
	cd $(JPEGDIR) && make clean
	cd $(PNGDIR) && make clean
	cd $(ZLIBDIR) && make clean
	cd $(QHULLDIR) && make clean
	cd $(FTDIR) && make clean
	cd $(XERCESCDIR) && make clean
	rm -rf $(OBJS)

=== examples/jsterm_standalone/Makefile ===
serve: check_gr.js
	python3 -m http.server

check_gr.js:
	@if [ ! -e "gr.js" ]; then \
	    >&2 echo "Please compile gr.js first (\`make -C js\` in the root directory)."; \
	    exit 1; \
	fi


.PHONY: serve check_gr.js

=== examples/qt4_ex/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1...3.19)

project(gr_qt4_example LANGUAGES CXX)

set(GRDIR
    "/usr/local/gr"
    CACHE STRING "Default value for GRDIR"
)
list(APPEND CMAKE_PREFIX_PATH "${GRDIR}")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

find_package(Qt4 REQUIRED)
find_package(GR NO_MODULE REQUIRED)

add_executable(main main.cpp main_window.cpp)
target_link_libraries(main PRIVATE GR::qt4gr)

=== examples/qt6_ex/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

project(gr_qt6_example LANGUAGES CXX)

set(GRDIR
    "/usr/local/gr"
    CACHE STRING "Default value for GRDIR"
)
list(APPEND CMAKE_PREFIX_PATH "${GRDIR}")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

find_package(
  Qt6
  COMPONENTS Core Widgets
  REQUIRED
)
find_package(GR NO_MODULE REQUIRED)

add_executable(main main.cpp main_window.cpp)
target_link_libraries(main PRIVATE GR::qt6gr)

=== lib/gr3/Makefile ===
ifeq ($(strip $(THIRDPARTYDIR)),)
override THIRDPARTYDIR = $(abspath $(CURDIR)/../../3rdparty/build)
endif

       GRDIR = /usr/local/gr
      LIBDIR = $(DESTDIR)$(GRDIR)/lib
      INCDIR = $(DESTDIR)$(GRDIR)/include

UNAME := $(shell uname)

    INCLUDES = -I$(THIRDPARTYDIR)/include -I../gr -I../gks
      GRLIBS = -L../gr -lGR
     PNGLIBS = $(THIRDPARTYDIR)/lib/libpng.a
    JPEGLIBS = $(THIRDPARTYDIR)/lib/libjpeg.a
       ZLIBS = $(THIRDPARTYDIR)/lib/libz.a
      CFLAGS = -O3 -Wall -Wextra -pedantic -fPIC -pthread -DGRDIR=\"$(GRDIR)\" $(EXTRA_CFLAGS)
        OBJS = gr3.o gr3_convenience.o gr3_html.o gr3_povray.o gr3_png.o \
               gr3_jpeg.o gr3_gr.o gr3_mc.o gr3_slices.o gr3_sr.o

ifeq ($(UNAME), Darwin)
GR_SHARED_LIBRARY_SUFFIX ?= .dylib
      CFLAGS+= -mmacosx-version-min=10.15
      GLLIBS = -framework OpenGL -framework Cocoa
        OBJS+= gr3_cgl.o
INSTALL_NAME = -Wl,-install_name,@rpath/libGR3${GR_SHARED_LIBRARY_SUFFIX}
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,@loader_path/. -mmacosx-version-min=10.15
     SOFLAGS = -dynamiclib
        LIBS =
else
GR_SHARED_LIBRARY_SUFFIX ?= .so
      GLLIBS =
PLATFORMLIBS = -lX11 -lGL
        OBJS+= gr3_glx.o
INSTALL_NAME =
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,'$$ORIGIN/.'
     SOFLAGS = -shared -Wl,-soname,$@
        LIBS = -ldl
endif

default:
	$(MAKE) -C ../.. Makedefs
	$(MAKE) `cat ../../Makedefs`

all: targets

targets: prerequisites libGR3${GR_SHARED_LIBRARY_SUFFIX}

prerequisites:
	$(MAKE) -C ../gr

ifeq ($(UNAME), $(filter $(UNAME),Linux FreeBSD))  # if $(UNAME) in (Linux, FreeBSD)
targets: libGR3platform.so
install: install_platform
install_platform:
	@if [ ! -d $(DESTDIR)$(GRDIR) ]; then mkdir -m 755 $(DESTDIR)$(GRDIR); fi
	@if [ ! -d $(LIBDIR) ]; then mkdir -m 755 $(LIBDIR); fi
	cp -r libGR3platform.so $(LIBDIR)
libGR3platform.so: gr3_platform_glx.c
	${CC} -o $@ $^ $(CFLAGS) $(INCLUDES) $(PLATFORMLIBS) $(SOFLAGS) $(LDFLAGS) $(GLDEFS)
endif

.c.o:
	${CC} -c $< $(CFLAGS) $(INCLUDES) $(GLDEFS)

libGR3${GR_SHARED_LIBRARY_SUFFIX}: $(OBJS)
	${CC} -o $@ $^ $(CFLAGS) $(JPEGLIBS) $(GLLIBS) $(GRLIBS) $(PNGLIBS) $(ZLIBS) $(LIBS) \
	$(SOFLAGS) $(LDFLAGS) $(INSTALL_NAME)

gr3.c: gr3.h gr3_internals.h gr3_sr.h
gr3_internals.h: gr3.h gr3_glx.h gr3_cgl.h
gr3_glx.c: gr3_glx.h
gr3_cgl.c: gr3_cgl.h
gr3_convenience.c: gr3_internals.h
gr3_html.c: gr3_internals.h
gr3_povray.c: gr3_internals.h
gr3_png.c: gr3_internals.h
gr3_jpeg.c: gr3_internals.h
gr3_gr.c: gr3_internals.h gr3_sr.h
gr3_mc.c: gr3.h gr3_mc_data.h
gr3_slices.c: gr3.h
gr3_sr.c: gr3_sr.h

install: targets
	@if [ ! -d $(DESTDIR)$(GRDIR) ]; then mkdir -m 755 $(DESTDIR)$(GRDIR); fi
	@if [ ! -d $(LIBDIR) ]; then mkdir -m 755 $(LIBDIR); fi
	cp -p libGR3${GR_SHARED_LIBRARY_SUFFIX} $(LIBDIR)
	@if [ ! -d $(INCDIR) ]; then mkdir -m 755 $(INCDIR); fi
	cp -p gr3.h $(INCDIR)

clean:
	$(MAKE) -C ../gr clean
	rm -rf libGR3${GR_SHARED_LIBRARY_SUFFIX}*
	rm -rf libGR3platform.so*
	rm -f *.o

=== lib/grm/test/public_api/grm/snoop/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1...3.16)

project(
  grm_test_snoop
  DESCRIPTION "Test GRM against the GR.jl snoop example"
  LANGUAGES C
)

add_library(c_rand SHARED c_rand.c)
target_link_libraries(c_rand PRIVATE m)
target_compile_options(c_rand PRIVATE ${COMPILER_OPTION_ERROR_IMPLICIT})
set_target_properties(c_rand PROPERTIES C_STANDARD 90 C_STANDARD_REQUIRED ON C_EXTENSIONS OFF)

add_executable(snoop snoop.c)
target_link_libraries(snoop PRIVATE grm_shared)
target_link_libraries(snoop PRIVATE gr_shared)
target_link_libraries(snoop PRIVATE gks_shared)
target_link_libraries(snoop PRIVATE c_rand)
target_link_libraries(snoop PRIVATE m)
target_compile_options(snoop PRIVATE ${COMPILER_OPTION_ERROR_IMPLICIT})
set_target_properties(snoop PROPERTIES C_STANDARD 90 C_STANDARD_REQUIRED ON C_EXTENSIONS OFF)
if(APPLE)
  set_target_properties(snoop PROPERTIES BUILD_RPATH "@loader_path/.")
else()
  set_target_properties(snoop PROPERTIES BUILD_RPATH "$ORIGIN/.")
endif()

=== debian/changelog ===
gr-framework (0.73.12+dfsg-2) unstable; urgency=medium

  * d/control
    - Require fonts-dejavu-core for default font
    - Require fonts-urw-base35,fonts-stix as built-in supported fonts
  * d/libgr-framework0.links
    - Add missing fallback about font metrics
  * d/patches/use-dejavu-sans-ttf.patch
    - Use DejaVuSans by default

 -- Kentaro Hayashi <kenhys@xdump.org>  Fri, 07 Feb 2025 21:56:38 +0900

gr-framework (0.73.12+dfsg-1) unstable; urgency=medium

  * New upstream version 0.73.12+dfsg

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 25 Jan 2025 18:19:43 +0900

=== debian/control ===
--- 
+++ 
@@ -94,7 +94,10 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- dvipng
+ dvipng,
+ fonts-dejavu-core,
+ fonts-urw-base35,
+ fonts-stix
 Description: Library of Graphical Kernel System (GKS) and OpenGL
  GR is a universal framework for cross-platform visualization
  applications. It offers developers a compact, portable and consistent
